diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/attribute-test-suite.cc ns-3.39/src/core/test/attribute-test-suite.cc
--- ns-3.38/src/core/test/attribute-test-suite.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/test/attribute-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
@@ -237,6 +237,11 @@
                               ObjectMapValue(),
                               MakeObjectMapAccessor(&AttributeObjectTest::m_map1),
                               MakeObjectMapChecker<Derived>())
+                .AddAttribute("TestUnorderedMap",
+                              "help text",
+                              ObjectMapValue(),
+                              MakeObjectMapAccessor(&AttributeObjectTest::m_unorderedMap),
+                              MakeObjectMapChecker<Derived>())
                 .AddAttribute("IntegerTraceSource1",
                               "help text",
                               IntegerValue(-2),
@@ -351,6 +356,24 @@
     }
 
     /**
+     * Adds an object to the unordered map.
+     * \param i The index to assign to the object.
+     */
+    void AddToUnorderedMap(uint64_t i)
+    {
+        m_unorderedMap.insert({i, CreateObject<Derived>()});
+    }
+
+    /**
+     * Remove an object from the first map.
+     * \param i The index to assign to the object.
+     */
+    void RemoveFromUnorderedMap(uint64_t i)
+    {
+        m_unorderedMap.erase(i);
+    }
+
+    /**
      * Invoke the m_cb callback.
      * \param a The first argument of the callback.
      * \param b The second argument of the callback.
@@ -477,15 +500,17 @@
     int16_t m_int16SetGet;                   //!< 16-bit integer set-get.
     uint8_t m_uint8;                         //!< 8-bit integer.
     float m_float;                           //!< float.
-    enum Test_e m_enum;                      //!< Enum.
-    enum Test_e m_enumSetGet;                //!< Enum set-get.
+    Test_e m_enum;                           //!< Enum.
+    Test_e m_enumSetGet;                     //!< Enum set-get.
     Ptr<RandomVariableStream> m_random;      //!< Random number generator.
     std::vector<Ptr<Derived>> m_vector1;     //!< First vector of derived objects.
     std::vector<Ptr<Derived>> m_vector2;     //!< Second vector of derived objects.
     std::map<uint32_t, Ptr<Derived>> m_map1; //!< Map of uint32_t, derived objects.
-    Callback<void, int8_t> m_cbValue;        //!< Callback accepting an integer.
-    TracedValue<int8_t> m_intSrc1;           //!< First int8_t Traced value.
-    TracedValue<int8_t> m_intSrc2;           //!< Second int8_t Traced value.
+    std::unordered_map<uint64_t, Ptr<Derived>>
+        m_unorderedMap;               //!< Unordered map of uint64_t, derived objects.
+    Callback<void, int8_t> m_cbValue; //!< Callback accepting an integer.
+    TracedValue<int8_t> m_intSrc1;    //!< First int8_t Traced value.
+    TracedValue<int8_t> m_intSrc2;    //!< Second int8_t Traced value.
 
     /// Traced callbacks for (double, int, float) values.
     typedef void (*NumericTracedCallback)(double, int, float);
@@ -1329,6 +1354,42 @@
     //
     p->GetAttribute("TestMap1", map);
     NS_TEST_ASSERT_MSG_EQ(map.GetN(), 2, "ObjectVectorValue \"TestMap1\" should be incremented");
+
+    //
+    // Test that ObjectMapValue is iterable with an underlying unordered_map
+    //
+    ObjectMapValue unorderedMap;
+    // Add objects at 1, 2, 3, 4
+    p->AddToUnorderedMap(4);
+    p->AddToUnorderedMap(2);
+    p->AddToUnorderedMap(1);
+    p->AddToUnorderedMap(3);
+    // Remove object 2
+    p->RemoveFromUnorderedMap(2);
+    p->GetAttribute("TestUnorderedMap", unorderedMap);
+    NS_TEST_ASSERT_MSG_EQ(unorderedMap.GetN(),
+                          3,
+                          "ObjectMapValue \"TestUnorderedMap\" should have three values");
+    Ptr<Object> o1 = unorderedMap.Get(1);
+    NS_TEST_ASSERT_MSG_NE(o1,
+                          nullptr,
+                          "ObjectMapValue \"TestUnorderedMap\" should have value with key 1");
+    Ptr<Object> o2 = unorderedMap.Get(2);
+    NS_TEST_ASSERT_MSG_EQ(o2,
+                          nullptr,
+                          "ObjectMapValue \"TestUnorderedMap\" should not have value with key 2");
+    auto it = unorderedMap.Begin();
+    NS_TEST_ASSERT_MSG_EQ(it->first,
+                          1,
+                          "ObjectMapValue \"TestUnorderedMap\" should have a value with key 1");
+    it++;
+    NS_TEST_ASSERT_MSG_EQ(it->first,
+                          3,
+                          "ObjectMapValue \"TestUnorderedMap\" should have a value with key 3");
+    it++;
+    NS_TEST_ASSERT_MSG_EQ(it->first,
+                          4,
+                          "ObjectMapValue \"TestUnorderedMap\" should have a value with key 4");
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/examples-to-run.py ns-3.39/src/core/test/examples-to-run.py
--- ns-3.38/src/core/test/examples-to-run.py	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/examples-to-run.py	2023-07-05 14:23:47.769427300 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/matrix-array-test-suite.cc ns-3.39/src/core/test/matrix-array-test-suite.cc
--- ns-3.38/src/core/test/matrix-array-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/matrix-array-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
@@ -38,7 +38,7 @@
 
 /**
  * \ingroup matrixArray-tests
- *  MatrixArray test for testing constructors
+ *  MatrixArray test case for testing constructors, operators and other functions
  */
 template <class T>
 class MatrixArrayTestCase : public TestCase
@@ -50,7 +50,7 @@
      *
      * \param [in] name reference name
      */
-    MatrixArrayTestCase<T>(const std::string name);
+    MatrixArrayTestCase<T>(const std::string& name);
 
     /** Destructor. */
     ~MatrixArrayTestCase<T>() override;
@@ -83,7 +83,7 @@
 };
 
 template <class T>
-MatrixArrayTestCase<T>::MatrixArrayTestCase(const std::string name)
+MatrixArrayTestCase<T>::MatrixArrayTestCase(const std::string& name)
     : TestCase(name)
 {
 }
@@ -100,9 +100,9 @@
     // test multiplication of matrices (MatrixArray containing only 1 matrix)
     MatrixArray<T> m1 = MatrixArray<T>(2, 3);
     MatrixArray<T> m2 = MatrixArray<T>(m1.GetNumCols(), m1.GetNumRows());
-    for (auto i = 0; i < m1.GetNumRows(); ++i)
+    for (size_t i = 0; i < m1.GetNumRows(); ++i)
     {
-        for (auto j = 0; j < m1.GetNumCols(); ++j)
+        for (size_t j = 0; j < m1.GetNumCols(); ++j)
         {
             m1(i, j) = 1;
             m2(j, i) = 1;
@@ -121,9 +121,9 @@
     NS_TEST_ASSERT_MSG_EQ(m3.GetNumRows(),
                           m3.GetNumCols(),
                           "The number of rows and cols should be equal");
-    for (auto i = 0; i < m3.GetNumCols(); ++i)
+    for (size_t i = 0; i < m3.GetNumCols(); ++i)
     {
-        for (auto j = 0; j < m3.GetNumRows(); ++j)
+        for (size_t j = 0; j < m3.GetNumRows(); ++j)
         {
             NS_TEST_ASSERT_MSG_EQ(std::real(m3(i, j)),
                                   m1.GetNumCols(),
@@ -133,9 +133,9 @@
 
     // multiplication with a scalar value
     MatrixArray<T> m4 = m3 * (static_cast<T>(5.0));
-    for (auto i = 0; i < m4.GetNumCols(); ++i)
+    for (size_t i = 0; i < m4.GetNumCols(); ++i)
     {
-        for (auto j = 0; j < m4.GetNumRows(); ++j)
+        for (size_t j = 0; j < m4.GetNumRows(); ++j)
         {
             NS_TEST_ASSERT_MSG_EQ(m3(i, j) * (static_cast<T>(5.0)),
                                   m4(i, j),
@@ -147,11 +147,11 @@
     // test multiplication of arrays of matrices
     MatrixArray<T> m5 = MatrixArray<T>(2, 3, 2);
     MatrixArray<T> m6 = MatrixArray<T>(m5.GetNumCols(), m5.GetNumRows(), m5.GetNumPages());
-    for (auto p = 0; p < m5.GetNumPages(); ++p)
+    for (size_t p = 0; p < m5.GetNumPages(); ++p)
     {
-        for (auto i = 0; i < m5.GetNumRows(); ++i)
+        for (size_t i = 0; i < m5.GetNumRows(); ++i)
         {
-            for (auto j = 0; j < m5.GetNumCols(); ++j)
+            for (size_t j = 0; j < m5.GetNumCols(); ++j)
             {
                 m5(i, j, p) = 1;
                 m6(j, i, p) = 1;
@@ -169,11 +169,11 @@
                           m7.GetNumCols(),
                           "The number of rows and cols should be equal");
 
-    for (auto p = 0; p < m7.GetNumPages(); ++p)
+    for (size_t p = 0; p < m7.GetNumPages(); ++p)
     {
-        for (auto i = 0; i < m7.GetNumCols(); ++i)
+        for (size_t i = 0; i < m7.GetNumCols(); ++i)
         {
-            for (auto j = 0; j < m7.GetNumRows(); ++j)
+            for (size_t j = 0; j < m7.GetNumRows(); ++j)
             {
                 NS_TEST_ASSERT_MSG_EQ(std::real(m7(i, j, p)),
                                       m5.GetNumCols(),
@@ -191,6 +191,27 @@
     NS_TEST_ASSERT_MSG_EQ(m6, m8, "These two matrices should be equal");
     NS_LOG_INFO("m8 = m5.Transpose ()" << m8);
 
+    // test transpose using initialization arrays
+    std::valarray<int> a{0, 0, 0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4};
+    std::valarray<int> b{0, 1, 2, 3, 4, 0, 1, 2, 3, 4, 0, 1, 2, 3, 4};
+    std::valarray<T> aCasted(a.size());
+    std::valarray<T> bCasted(b.size());
+    for (size_t i = 0; i < a.size(); ++i)
+    {
+        aCasted[i] = static_cast<T>(a[i]);
+    }
+    for (size_t i = 0; i < b.size(); ++i)
+    {
+        bCasted[i] = static_cast<T>(b[i]);
+    }
+    m5 = MatrixArray<T>(3, 5, 1, aCasted);
+    m6 = MatrixArray<T>(5, 3, 1, bCasted);
+    m8 = m5.Transpose();
+    NS_TEST_ASSERT_MSG_EQ(m6, m8, "These two matrices should be equal");
+    NS_LOG_INFO("m5 (3, 5, 1):" << m5);
+    NS_LOG_INFO("m6 (5, 3, 1):" << m6);
+    NS_LOG_INFO("m8 (5, 3, 1) = m5.Transpose ()" << m8);
+
     // test 1D array creation, i.e. vector and transposing it
     MatrixArray<T> m9 = MatrixArray<T>(std::vector<T>({0, 1, 2, 3, 4, 5, 6, 7}));
     NS_TEST_ASSERT_MSG_EQ((m9.GetNumRows() == 8) && (m9.GetNumCols() == 1) &&
@@ -217,12 +238,14 @@
     NS_TEST_ASSERT_MSG_EQ(m10, m9, "m10 and m9 should be equal");
 
     // test multiplication by using an initialization matrixArray
-    std::valarray<int> a{0, 1, 2, 3, 4, 5, 0, 1, 2, 3, 4, 5};
-    std::valarray<int> b{0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1};
+    // matrix dimensions in each page are 2x3, 3x2, and the resulting matrix per page is a square
+    // matrix 2x2
+    a = {0, 1, 2, 3, 4, 5, 0, 1, 2, 3, 4, 5};
+    b = {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1};
     std::valarray<int> c{2, 3, 4, 6, 2, 3, 4, 6};
-    std::valarray<T> aCasted(a.size());
-    std::valarray<T> bCasted(b.size());
-    std::valarray<T> cCasted(c.size());
+    aCasted = std::valarray<T>(a.size());
+    bCasted = std::valarray<T>(b.size());
+    std::valarray<T> cCasted = std::valarray<T>(c.size());
 
     for (size_t i = 0; i < a.size(); ++i)
     {
@@ -247,9 +270,88 @@
                           m14.GetNumRows(),
                           "The number of rows is not as expected.");
     NS_TEST_ASSERT_MSG_EQ(m13, m14, "The values are not equal.");
-    NS_LOG_INFO("m11:" << m11);
-    NS_LOG_INFO("m12:" << m12);
-    NS_LOG_INFO("m13 = matrixArrayA * matrixArrayB:" << m13);
+    NS_LOG_INFO("m11 (2,3,2):" << m11);
+    NS_LOG_INFO("m12 (3,2,2):" << m12);
+    NS_LOG_INFO("m13 = m11 * m12:" << m13);
+
+    // test multiplication by using an initialization matrixArray
+    // matrices have different number of elements per page
+    // matrix dimensions in each page are 4x3, 3x2, and the resulting matrix
+    // dimensions are 4x2
+    a = std::valarray<int>(
+        {0, 1, 0, 1, 2, 3, 2, 3, 4, 5, 4, 5, 0, 1, 0, 1, 2, 3, 2, 3, 4, 5, 4, 5});
+    b = std::valarray<int>({0, 1, 0, 1, 0, 1, 0, 10, 0, 10, 0, 10});
+    c = std::valarray<int>({2, 3, 2, 3, 4, 6, 4, 6, 20, 30, 20, 30, 40, 60, 40, 60});
+    aCasted = std::valarray<T>(a.size());
+    bCasted = std::valarray<T>(b.size());
+    cCasted = std::valarray<T>(c.size());
+
+    for (size_t i = 0; i < a.size(); ++i)
+    {
+        aCasted[i] = static_cast<T>(a[i]);
+    }
+    for (size_t i = 0; i < b.size(); ++i)
+    {
+        bCasted[i] = static_cast<T>(b[i]);
+    }
+    for (size_t i = 0; i < c.size(); ++i)
+    {
+        cCasted[i] = static_cast<T>(c[i]);
+    }
+
+    m11 = MatrixArray<T>(4, 3, 2, aCasted);
+    m12 = MatrixArray<T>(3, 2, 2, bCasted);
+    m13 = m11 * m12;
+    m14 = MatrixArray<T>(4, 2, 2, cCasted);
+    NS_TEST_ASSERT_MSG_EQ(m13.GetNumCols(),
+                          m14.GetNumCols(),
+                          "The number of columns is not as expected.");
+    NS_TEST_ASSERT_MSG_EQ(m13.GetNumRows(),
+                          m14.GetNumRows(),
+                          "The number of rows is not as expected.");
+    NS_TEST_ASSERT_MSG_EQ(m13, m14, "The values are not equal.");
+    NS_LOG_INFO("m11 (4,3,2):" << m11);
+    NS_LOG_INFO("m12 (3,2,2):" << m12);
+    NS_LOG_INFO("m13 = m11 * m12:" << m13);
+
+    // test multiplication by using an initialization matrixArray
+    // matrices have different number of elements per page
+    // matrix dimensions in each page are 1x3, 3x2, and the resulting matrix has
+    // dimensions 1x2
+    a = std::valarray<int>({5, 4, 5, 5, 4, 5});
+    b = std::valarray<int>({0, 1, 0, 1, 0, 1, 1, 2, 3, 10, 100, 1000});
+    c = std::valarray<int>({4, 10, 28, 5450});
+    aCasted = std::valarray<T>(a.size());
+    bCasted = std::valarray<T>(b.size());
+    cCasted = std::valarray<T>(c.size());
+
+    for (size_t i = 0; i < a.size(); ++i)
+    {
+        aCasted[i] = static_cast<T>(a[i]);
+    }
+    for (size_t i = 0; i < b.size(); ++i)
+    {
+        bCasted[i] = static_cast<T>(b[i]);
+    }
+    for (size_t i = 0; i < c.size(); ++i)
+    {
+        cCasted[i] = static_cast<T>(c[i]);
+    }
+
+    m11 = MatrixArray<T>(1, 3, 2, aCasted);
+    m12 = MatrixArray<T>(3, 2, 2, bCasted);
+    m13 = m11 * m12;
+    m14 = MatrixArray<T>(1, 2, 2, cCasted);
+    NS_TEST_ASSERT_MSG_EQ(m13.GetNumCols(),
+                          m14.GetNumCols(),
+                          "The number of columns is not as expected.");
+    NS_TEST_ASSERT_MSG_EQ(m13.GetNumRows(),
+                          m14.GetNumRows(),
+                          "The number of rows is not as expected.");
+    NS_TEST_ASSERT_MSG_EQ(m13, m14, "The values are not equal.");
+    NS_LOG_INFO("m11 (1,3,2):" << m11);
+    NS_LOG_INFO("m12 (3,2,2):" << m12);
+    NS_LOG_INFO("m13 = m11 * m12:" << m13);
 
     // test MultiplyByLeftAndRightMatrix
     std::valarray<int> d{1, 1, 1};
@@ -320,23 +422,100 @@
     NS_LOG_INFO("m24 = m20 * m22 * m21" << m24);
 
     // test initialization with moving
+    size_t lCastedSize = lCasted.size();
     NS_LOG_INFO("size() of lCasted before move: " << lCasted.size());
     MatrixArray<T> m25 = MatrixArray<T>(2, 2, 2, std::move(lCasted));
-    NS_LOG_INFO("size() of lCasted after move: " << lCasted.size());
     NS_LOG_INFO("m25.GetSize ()" << m25.GetSize());
-    NS_TEST_ASSERT_MSG_EQ(lCasted.size(), 0, "The size of lCasted should be 0.");
+    NS_TEST_ASSERT_MSG_EQ(lCastedSize, m25.GetSize(), "The number of elements are not equal.");
 
+    size_t hCastedSize = hCasted.size();
     NS_LOG_INFO("size() of hCasted before move: " << hCasted.size());
     MatrixArray<T> m26 = MatrixArray<T>(2, 3, std::move(hCasted));
-    NS_LOG_INFO("size() of hCasted after move: " << hCasted.size());
     NS_LOG_INFO("m26.GetSize ()" << m26.GetSize());
-    NS_TEST_ASSERT_MSG_EQ(hCasted.size(), 0, "The size of hCasted should be 0.");
+    NS_TEST_ASSERT_MSG_EQ(hCastedSize, m26.GetSize(), "The number of elements are not equal.");
 
+    size_t jCastedSize = jCasted.size();
     NS_LOG_INFO("size() of jCasted before move: " << jCasted.size());
     MatrixArray<T> m27 = MatrixArray<T>(std::move(jCasted));
-    NS_LOG_INFO("size() of jCasted after move: " << jCasted.size());
     NS_LOG_INFO("m27.GetSize ()" << m27.GetSize());
-    NS_TEST_ASSERT_MSG_EQ(hCasted.size(), 0, "The size of jCasted should be 0.");
+    NS_TEST_ASSERT_MSG_EQ(jCastedSize, m27.GetSize(), "The number of elements are not equal.");
+}
+
+/**
+ * \ingroup matrixArray-tests
+ *  Test for testing functions that apply to MatrixArrays that use complex numbers,
+ *  such as HermitianTranspose that is only defined for complex type
+ */
+class ComplexMatrixArrayTestCase : public TestCase
+{
+  public:
+    /** Constructor*/
+    ComplexMatrixArrayTestCase();
+    /**
+     * Constructor
+     *
+     * \param [in] name reference name
+     */
+    ComplexMatrixArrayTestCase(const std::string& name);
+    /** Destructor*/
+    ~ComplexMatrixArrayTestCase() override;
+
+  private:
+    void DoRun() override;
+};
+
+ComplexMatrixArrayTestCase::ComplexMatrixArrayTestCase()
+    : TestCase("ComplexMatrixArrayTestCase")
+{
+}
+
+ComplexMatrixArrayTestCase::ComplexMatrixArrayTestCase(const std::string& name)
+    : TestCase(name)
+{
+}
+
+ComplexMatrixArrayTestCase::~ComplexMatrixArrayTestCase()
+{
+}
+
+void
+ComplexMatrixArrayTestCase::DoRun()
+{
+    std::valarray<std::complex<double>> complexValarray1 = {
+        {1, 1},
+        {2, 2},
+        {3, 3},
+        {4, 4},
+        {5, 5},
+        {6, 6},
+        {-1, 1},
+        {-2, 2},
+        {-3, 3},
+        {-4, 4},
+        {-5, 5},
+        {-6, 6},
+    };
+    std::valarray<std::complex<double>> complexValarray2 = {
+        {1, -1},
+        {4, -4},
+        {2, -2},
+        {5, -5},
+        {3, -3},
+        {6, -6},
+        {-1, -1},
+        {-4, -4},
+        {-2, -2},
+        {-5, -5},
+        {-3, -3},
+        {-6, -6},
+    };
+    ComplexMatrixArray m1 = ComplexMatrixArray(3, 2, 2, complexValarray1);
+    ComplexMatrixArray m2 = ComplexMatrixArray(2, 3, 2, complexValarray2);
+    ComplexMatrixArray m3 = m1.HermitianTranspose();
+    NS_LOG_INFO("m1 (3, 2, 2):" << m1);
+    NS_LOG_INFO("m2 (2, 3, 2):" << m2);
+    NS_LOG_INFO("m3 (2, 3, 2):" << m3);
+    NS_TEST_ASSERT_MSG_EQ(m2, m3, "m2 and m3 matrices should be equal");
 }
 
 /**
@@ -357,6 +536,7 @@
     AddTestCase(
         new MatrixArrayTestCase<std::complex<double>>("Test MatrixArray<std::complex<double>>"));
     AddTestCase(new MatrixArrayTestCase<int>("Test MatrixArray<int>"));
+    AddTestCase(new ComplexMatrixArrayTestCase("Test ComplexMatrixArray"));
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/object-test-suite.cc ns-3.39/src/core/test/object-test-suite.cc
--- ns-3.38/src/core/test/object-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/object-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
@@ -541,7 +541,7 @@
 
     //
     // Since a declared a BaseA, even if it is really a DerivedA, we should not
-    // be able to GetOBject for a DerivedA since this would break the type
+    // be able to GetObject for a DerivedA since this would break the type
     // declaration.
     //
     NS_TEST_ASSERT_MSG_EQ(!a->GetObject<DerivedA>(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/random-variable-stream-test-suite.cc ns-3.39/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.38/src/core/test/random-variable-stream-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/random-variable-stream-test-suite.cc	2023-07-05 14:23:47.769427300 -0700
@@ -316,7 +316,7 @@
      */
     void SetTestSuiteSeed()
     {
-        if (m_seedSet == false)
+        if (!m_seedSet)
         {
             uint32_t seed;
             if (RngSeedManager::GetRun() == 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/simulator-test-suite.cc ns-3.39/src/core/test/simulator-test-suite.cc
--- ns-3.38/src/core/test/simulator-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/simulator-test-suite.cc	2023-07-05 14:23:47.773427200 -0700
@@ -115,14 +115,7 @@
 void
 SimulatorEventsTestCase::EventB(int b)
 {
-    if (b != 2 || NowUs() != 11)
-    {
-        m_b = false;
-    }
-    else
-    {
-        m_b = true;
-    }
+    m_b = !(b != 2 || NowUs() != 11);
     Simulator::Remove(m_idC);
     Simulator::Schedule(MicroSeconds(10), &SimulatorEventsTestCase::EventD, this, 4);
 }
@@ -136,14 +129,7 @@
 void
 SimulatorEventsTestCase::EventD(int d)
 {
-    if (d != 4 || NowUs() != (11 + 10))
-    {
-        m_d = false;
-    }
-    else
-    {
-        m_d = true;
-    }
+    m_d = !(d != 4 || NowUs() != (11 + 10));
 }
 
 void
@@ -185,7 +171,11 @@
     NS_TEST_EXPECT_MSG_EQ(m_d, true, "Event D did not run ?");
 
     EventId anId = Simulator::ScheduleNow(&SimulatorEventsTestCase::Eventfoo0, this);
+
+    // Test copy assignment operator
+    // NOLINTNEXTLINE(performance-unnecessary-copy-initialization)
     EventId anotherId = anId;
+
     NS_TEST_EXPECT_MSG_EQ(!(anId.IsExpired() || anotherId.IsExpired()),
                           true,
                           "Event should not have expired yet.");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/trickle-timer-test-suite.cc ns-3.39/src/core/test/trickle-timer-test-suite.cc
--- ns-3.38/src/core/test/trickle-timer-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/trickle-timer-test-suite.cc	2023-07-05 14:23:47.773427200 -0700
@@ -96,7 +96,7 @@
 void
 TrickleTimerTestCase::ExpireTimer()
 {
-    if (m_enableDataCollection == false)
+    if (!m_enableDataCollection)
     {
         return;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/type-id-test-suite.cc ns-3.39/src/core/test/type-id-test-suite.cc
--- ns-3.38/src/core/test/type-id-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/type-id-test-suite.cc	2023-07-05 14:23:47.773427200 -0700
@@ -59,10 +59,8 @@
   private:
     void DoRun() override;
 
-    enum
-    {
-        HashChainFlag = 0x80000000
-    };
+    /// Hash chaining flag, copied from type-id.cc:IidManager
+    static constexpr auto HASH_CHAIN_FLAG{0x80000000};
 };
 
 UniqueTypeIdTestCase::UniqueTypeIdTestCase()
@@ -93,7 +91,7 @@
     {
         const TypeId tid = TypeId::GetRegistered(i);
         std::cout << suite << "" << std::setw(6) << tid.GetUid();
-        if (tid.GetHash() & HashChainFlag)
+        if (tid.GetHash() & HASH_CHAIN_FLAG)
         {
             std::cout << "  chain";
         }
@@ -108,9 +106,9 @@
                               TypeId::LookupByName(tid.GetName()).GetUid(),
                               "LookupByName returned different TypeId for " << tid.GetName());
 
-        // Mask off HashChainFlag in this test, since tid might have been chained
-        NS_TEST_ASSERT_MSG_EQ((tid.GetHash() & (~HashChainFlag)),
-                              (hasher.clear().GetHash32(tid.GetName()) & (~HashChainFlag)),
+        // Mask off HASH_CHAIN_FLAG in this test, since tid might have been chained
+        NS_TEST_ASSERT_MSG_EQ((tid.GetHash() & (~HASH_CHAIN_FLAG)),
+                              (hasher.clear().GetHash32(tid.GetName()) & (~HASH_CHAIN_FLAG)),
                               "TypeId .hash and Hash32 (.name) unequal for " << tid.GetName());
 
         NS_TEST_ASSERT_MSG_EQ(tid.GetUid(),
@@ -135,10 +133,8 @@
   private:
     void DoRun() override;
 
-    enum
-    {
-        HashChainFlag = 0x80000000
-    };
+    /// Hash chaining flag, copied from type-id.cc:IidManager
+    static constexpr auto HASH_CHAIN_FLAG{0x80000000};
 };
 
 CollisionTestCase::CollisionTestCase()
@@ -167,14 +163,14 @@
     TypeId t2(t2Name);
 
     // Check that they are alphabetical: t1 name < t2 name
-    NS_TEST_ASSERT_MSG_EQ((t1.GetHash() & HashChainFlag),
+    NS_TEST_ASSERT_MSG_EQ((t1.GetHash() & HASH_CHAIN_FLAG),
                           0,
-                          "First and lesser TypeId has HashChainFlag set");
+                          "First and lesser TypeId has HASH_CHAIN_FLAG set");
     std::cout << suite << "collision: first,lesser  not chained: OK" << std::endl;
 
-    NS_TEST_ASSERT_MSG_NE((t2.GetHash() & HashChainFlag),
+    NS_TEST_ASSERT_MSG_NE((t2.GetHash() & HASH_CHAIN_FLAG),
                           0,
-                          "Second and greater TypeId does not have HashChainFlag set");
+                          "Second and greater TypeId does not have HASH_CHAIN_FLAG set");
     std::cout << suite << "collision: second,greater    chained: OK" << std::endl;
 
     // Register colliding types in reverse alphabetical order
@@ -188,14 +184,14 @@
     TypeId t4(t4Name);
 
     // Check that they are alphabetical: t3 name > t4 name
-    NS_TEST_ASSERT_MSG_NE((t3.GetHash() & HashChainFlag),
+    NS_TEST_ASSERT_MSG_NE((t3.GetHash() & HASH_CHAIN_FLAG),
                           0,
-                          "First and greater TypeId does not have HashChainFlag set");
+                          "First and greater TypeId does not have HASH_CHAIN_FLAG set");
     std::cout << suite << "collision: first,greater     chained: OK" << std::endl;
 
-    NS_TEST_ASSERT_MSG_EQ((t4.GetHash() & HashChainFlag),
+    NS_TEST_ASSERT_MSG_EQ((t4.GetHash() & HASH_CHAIN_FLAG),
                           0,
-                          "Second and lesser TypeId has HashChainFlag set");
+                          "Second and lesser TypeId has HASH_CHAIN_FLAG set");
     std::cout << suite << "collision: second,lesser not chained: OK" << std::endl;
 
     /** TODO Extra credit:  register three types whose hashes collide
@@ -321,7 +317,7 @@
     std::cerr << suite << "DeprecatedAttribute TypeId: " << tid.GetUid() << std::endl;
 
     //  Try the lookups
-    struct TypeId::AttributeInformation ainfo;
+    TypeId::AttributeInformation ainfo;
     NS_TEST_ASSERT_MSG_EQ(tid.LookupAttributeByName("attribute", &ainfo),
                           true,
                           "lookup new attribute");
@@ -334,7 +330,7 @@
     std::cerr << suite << "lookup old attribute:"
               << (ainfo.supportLevel == TypeId::DEPRECATED ? "deprecated" : "error") << std::endl;
 
-    struct TypeId::TraceSourceInformation tinfo;
+    TypeId::TraceSourceInformation tinfo;
     Ptr<const TraceSourceAccessor> acc;
     acc = tid.LookupTraceSourceByName("trace", &tinfo);
     NS_TEST_ASSERT_MSG_NE(acc, nullptr, "lookup new trace source");
@@ -368,10 +364,8 @@
      */
     void Report(const std::string how, const uint32_t delta) const;
 
-    enum
-    {
-        REPETITIONS = 100000
-    };
+    /// Number of repetitions
+    static constexpr uint32_t REPETITIONS{100000};
 };
 
 LookupTimeTestCase::LookupTimeTestCase()
